<script setup lang="ts">
import { BoardState, Position } from '@go158/go-validator';

interface Emits {
  (event: 'positionClicked', position: Position): void;
}

const emits = defineEmits<Emits>();

const props = defineProps<{
  currentBoardState: BoardState;
}>();

const container = ref<HTMLDivElement>();

const { svg } = useSvgBoard({
  current: toRef(props, 'currentBoardState'),
  onPositionClicked: (position) => emits('positionClicked', position),
  showCharacters: ref(true),
  showCoordinates: ref(true),
});

watch(svg, (newSvg: SVGSVGElement) => container.value?.replaceChildren(newSvg));
onMounted(() => container.value?.replaceChildren(svg.value));
</script>

<template>
  <div ref="container" class="overflow-hidden rounded-3xl" />
</template>
